/*
 * ListenerThread.java, Java class launcher 
 * Copyright (C) 2002-2003 TAKAHASHI,Toru (torutk@alles.or.jp)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.gr.java_conf.torutk.jlauncher;

import java.net.ServerSocket;
import java.net.Socket;
import java.io.InputStream;
import java.io.IOException;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.BufferedWriter;
import java.io.OutputStreamWriter;
import java.io.OutputStream;

/**
 * \PbgMeLXgCommandDispatcher֓]B
 * eLXǵAsPʂ1̃R}h\B
 *
 * @author Toru TAKAHASHI
 * @version $Revision: 1.2 $
 */
public class ListenerThread extends Thread {
    private ServerSocket server;
    private CommandDispatcher commandDispatcher;

    /**
     * <code>ListenerThread</code>CX^X𐶐B
     * 
     * @param dispatcher a <code>CommandDispatcher</code> value
     * @param socket a <code>ServerSocket</code> value
     */
    public ListenerThread(CommandDispatcher dispatcher, ServerSocket socket) {
        commandDispatcher = dispatcher;
        server = socket;
    }

    public void run() {
        try {
            while (true) {
                System.out.println("about to wait");
                Socket socket = server.accept();
                System.out.println("opened socket from client");
                InputStream iStream = socket.getInputStream();
                BufferedReader reader =
                    new BufferedReader(new InputStreamReader(iStream));
                String request = reader.readLine();
                String response = commandDispatcher.dispatch(request);
                OutputStream oStream = socket.getOutputStream();
                BufferedWriter writer =
                    new BufferedWriter(new OutputStreamWriter(oStream));
                writer.write(response);
                writer.newLine();
                writer.flush();
            }
	} catch (IOException e) {
	    e.printStackTrace();
	    System.out.println("Failed to start");
	}
    }
}
