/*
 * Main.java, Java class launcher 
 * Copyright (C) 2002-2003 TAKAHASHI,Toru (torutk@alles.or.jp)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.gr.java_conf.torutk.jlauncher;
 
import java.net.ServerSocket;
import java.io.IOException;

/**
 * JavaNvO 'Mercury'Javaz}VN
 * main\bh񋟂B
 *
 * @author TAKAHASHI,Toru
 * @version $Revision: 1.3 $
 */
public class Main {
    private static int DEFAULT_PORT_NUMBER = 2345;
    private static int MINIMUM_PORT_NUMBER = 0;
    private static int MAXIMUM_PORT_NUMBER = 65535;

    public static void main(String[] args) {
        System.out.println("Java Fast Launch Program 'Mercury' $Date: 2003/08/17 14:55:56 $");
        System.out.println("Copyright (C) 2002-2003, TAKAHASHI,Toru <torutk@alles.or.jp>");
        int portNumber = DEFAULT_PORT_NUMBER;
        for (int i=0; i<args.length; i++) {
            if (args[i].startsWith("-Port=")) {
                int number = Integer.parseInt( (args[i].split("="))[1]);
                if (MINIMUM_PORT_NUMBER < number &&
                    number < MAXIMUM_PORT_NUMBER)
                {
                    portNumber = number;
                }
            }
        }

        try {
            System.out.println("Using port:" + portNumber);
            ServerSocket server = new ServerSocket(portNumber);
            ListenerThread listenerThread =
                new ListenerThread(new CommandDispatcher(), server);
            listenerThread.start();
        } catch (IOException e) {
            System.err.println("Socket creation error for port " + portNumber);
            e.printStackTrace();
        }
    }
} // Main
